/*global window, rJS, RSVP, console */
/*jslint nomen: true, indent: 2, maxerr: 3*/
(function (window, rJS) {
  "use strict";

  rJS(window)
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
          g.props.start_deferred = RSVP.defer();
        });
    })
    //////////////////////////////////////////////
    // acquired methods
    //////////////////////////////////////////////
    .declareAcquiredMethod("getUrlFor", "getUrlFor")
    .allowPublicAcquisition("getUrlFor", function (argument_list) {
      return this.getUrlFor(argument_list[0]);
    })
    .declareAcquiredMethod("crib_sw_get", "crib_sw_get")
    .allowPublicAcquisition("crib_sw_get", function (argument_list) {
      return this.crib_sw_get(argument_list[0]);
    })
    .declareAcquiredMethod("crib_sw_put", "crib_sw_put")
    .allowPublicAcquisition("crib_sw_put", function (argument_list) {
      return this.crib_sw_put(argument_list[0], argument_list[1]);
    })
    .declareMethod('render', function (options) {
      var gadget = this;
      if (options === undefined)
        options = {};
      gadget.props.options = options;
      return new RSVP.Queue()
        .push(function () {
          return gadget.props.start_deferred.resolve();
        })
        .push(function () {
          return gadget.getDeclaredGadget("zip_loader");
        })
        .push(function (zip_loader) {
          return zip_loader.render();
        });
    });
}(window, rJS));