/*global window, rJS, loopEventListener, RSVP */
/*jslint nomen: true, indent: 2, maxerr: 3*/
(function (window, rJS, loopEventListener) {
  "use strict";

  function setSiteGadgetUrl(gadget, event) {
    var site_editor_gadget_url, gadget_validator;
    site_editor_gadget_url = gadget.props.element.querySelector('form.site-editor-gadget-url .url').value;
    /*
    */
    return gadget.getDeclaredGadget("interface_validator")
      .push(function (result) {
        gadget_validator = result;
        gadget.props.element.querySelector('div.interface_validator')
              .style = "";
        return gadget_validator.render({
          gadget_to_check_url: site_editor_gadget_url,
          required_interface_list: ["crib-enable-interface.html"]
        });
      })
      .push(function (result) {
        if (result) {
          return gadget.setSetting("site_editor_gadget_url", site_editor_gadget_url)
          .push(function () {
            gadget.props.element.querySelector(".crib-site-save-status")
              .textContent = "Saved " + site_editor_gadget_url + " files at " + Date();
          });
        }
        gadget.props.element.querySelector(".crib-site-save-status")
          .textContent = "Error founds for " + site_editor_gadget_url + " at " + Date() + "Please see message bellow";
      });
  }

  rJS(window)
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
          g.props.start_deferred = RSVP.defer();
        });
    })
    .declareAcquiredMethod("getSetting", "getSetting")
    .declareAcquiredMethod("setSetting", "setSetting")
    .declareMethod('render', function (options) {
      var gadget = this;
      if (options === undefined)
        options = {};
      gadget.props.options = options;
      return new RSVP.Queue()
        .push(function () {
          var getURL = window.location;
          return gadget.getSetting(
            "site_editor_gadget_url",
             getURL.protocol + "//" + getURL.host + "/crib-enable.html"
          );
        })
        .push(function (site_editor_gadget_url) {
          gadget.props.element.querySelector('form.site-editor-gadget-url .url').value = site_editor_gadget_url;
          return gadget.props.start_deferred.resolve();
        });
    })
    .declareService(function () {
      var gadget = this;
      return new RSVP.Queue()
        .push(function () {
          return gadget.props.start_deferred.promise;
        })
        .push(function () {
          var promise_list = [];
          // promise to set Site to Edit
          promise_list.push(loopEventListener(
            gadget.props.element.querySelector(".site-editor-gadget-url"),
            'submit',
            false,
            function (event) {setSiteGadgetUrl(gadget, event); }
          ));
          return RSVP.all(promise_list);
        });
    });
}(window, rJS, loopEventListener));